; http://jirky.webz.cz/
;
; Klvesnice Ctrl + Alt + Delete s PIC 12F629 pro USB
;**************************************************************************
;*                                PIC12F629/675                           *
;*                             --------\/--------                         *
;*                       +5V  -|Vdd          Vss|-  0V                    *
;*                            -|osc1/GP5     GP0|-  vstup CTRL           *
;*              vstup ENTER  -|osc2/GP4     GP1|-  vstup ALT            *
;*                     tlac1  -|MCLR/GP3 INT/GP2|-  vstup DEL            *
;*                             ------------------                         *
;*                                                                        *
;**************************************************************************

list	p=12f629, R=DEC
include	"p12f629.inc"

RAM		equ	20h	; prvni adresa pameti RAM
SKLAV		equ	RAM+1	;
NSCAN		equ	RAM+2	;
TMP0		equ	RAM+3	; pomocn pro tn asu - 1
TMP1		equ	RAM+4	; pomocn pro tn asu - 2
TMP2		equ	RAM+5	; pomocn pro tn asu - 3
TMP3		equ	RAM+6	; pomocn pro tn asu - 4

EE_ADR		equ	9Bh	; !!! 70h - 7Fh pro vsechny banky !!! 

#define	CTRL		GPIO,0		; vstup CTRL
#define	ALT		GPIO,1		; vstup ALT
#define	DEL		GPIO,2		; vstup DEL
#define	tlac1		GPIO,3		; tlatko 1
#define	ENTER		GPIO,4		; vstup ENTER

	org	0x2007		; adresa konfigurace PIC16F629 a 675
	dw _BODEN_OFF & _CP_OFF & _PWRTE_OFF & _WDT_OFF & _INTRC_OSC_NOCLKOUT & _CPD_OFF & _MCLRE_OFF

;************************     Reset procesoru     *************************

	org	0x0000		; zacatek programu
	goto	INIT		; skok na pocatecni inicializaci

;************************ Inicializace procesoru  *************************

INIT	bcf	STATUS,RP0	; banka registru 0

	movlw	B'00111111'
	movwf	GPIO		; prednastavit 0 na GP0 - GP5

	movlw	b'00000111'	; =07h, digitalni vstupy na GP0 - GP2 (comparator OFF)
	movwf	CMCON
;       ------------------------
	bsf	STATUS,RP0	; banka registru 1

	movlw	B'00001000'
	movwf	TRISIO		; GP0-GP2, GP4, GP5 vystup, GP3 vstup trvale


	movlw	b'10000011'	; PULL-UPy ON, preddelic=1:16 pripojen k TMR0
	movwf	OPTION_REG
	bcf	STATUS,RP0	; banka registru 0


;************************     Hlavn program      *************************

MAIN	btfsc	GPIO,3		; kontrola tlatka 1
	goto	konec		; nebylo stisknuto - jdi na konec
	call	SCAN
	btfsc 	SKLAV,3		; trv impuls?
	goto	konec		; nebylo stisknuto - jdi na konec

	bcf	CTRL		; sepnut CTRL
	call	CEK100m
	bcf	ALT		; sepnut ALT
	call	CEK100m
	bcf	DEL		; sepnut DEL
	call	CEK100m
	bsf	DEL		; uvolnn DEL
	call	CEK100m
	bsf	ALT		; uvolnn ALT
	call	CEK100m
	bsf	CTRL		; uvolnn CTRL
	call	CEK100m
	bcf	ENTER		; sepnut ENTER
	call	CEK15m
	bsf	ENTER		; uvolnn ENTER
	call	SCAN
	btfss	SKLAV,3		; bylo uvolnno tlatko?
	goto	$-2

konec	call	CEK1m6
	goto	MAIN

;**************************************************************************
; skenovn tlatek
SCAN	movlw	.150		; poet ten do nscan
	movwf	NSCAN
	movfw	GPIO
	andlw	b'00001000'
	movwf	SKLAV
loop2	movfw	GPIO
	andlw	b'00001000'
	subwf	SKLAV,0
	bnz	SCAN
	decfsz	NSCAN,1
	goto	loop2
	return			; data v sklav
;**************************************************************************
	include	"inc_cekaci_smycky.inc"
;**************************************************************************
	end
